****** ASyncRun.man ************************************************************
*
*   ASyncRun  --  A `RunBack' clone for AmigaOS 2.04+  (v37.8 / 05-May-1995)
*
********************************************************************************

:ts=8


    SYNOPSIS
	Command/A,Args/M,Pri/K/N,Stack/K/N,CD/K,WaitForPort/K,Sync/S,WB/S,DoIO/S


    DESCRIPTION
	ASyncRun creates a distinct independant background process using the
	information you provide, thus allowing you to EndShell the shell from
	which ASyncRun was launched.


    OPTIONS
	- Command
		Name of the program you wish to ASyncRun. This variable
		must be a valid pathname or resident programname.

	- Args
		The argument(s) you wish to pass to the program. This
		may be null.

	- Pri
		The priority you wish to run <Command> at. MUST be in the
        	range from -128 to 127, but generally you should be careful
        	in using priorities outside of, say, +/- 5.

	- Stack
        	Stacksize for the child process. Defaults to 4096 bytes.

	- CD (v37.7+)
		Current dir for child. Defaults to parent's dir.

	- WaitForPort (v37.4+)
		Port to wait for before releasing the prompt. Please note
		that port names are case sensitive! ASyncRun will wait for
		up to 10 secs for this port name to appear on the public
		port list.

		NB: WaitForPort replaces the Delay switch in previous
		    versions of ASyncRun!!!

	- SyncRun (v37.5+)
		Don't return until child process finishes.

	- WBRun (v37.6+)
		Run program in Workbench mode using `WBStart-Handler'.

	- DoIO (***NEW!***)
		Use current Input() and Output() filehandles instead of
		running program in the background. Only in `Sync' mode.
		Requested by Timo Vehmaa <tive@alpha.hut.fi>.

	The SyncRun and WBRun options are mutually exclusive.


    ENVIRONMENT VARIABLES
	ASyncRun supports a few environment variables to make life a bit
	easier, should you not be satisfied with the default values:

	- def_CD (v37.7+)
		Sets default current dir. If not defined, the default is
		parent's dir (i.e. current directory of shell).

	- def_Pri (v37.6+)
		Default priority. If not defined, default is 0.

	- def_Stack (v37.6+)
		Default stack size. If not defined, ASyncRun uses a value
		of 4 kbytes.

	- CustomShell (v37.4+)
		Name of custom shell (e.g. `WShell'). Don't use this one
		unless you know what you're doing.

	- CopyVars (v37.7+)
		Boolean (y/n) to copy local vars (default: `yes'). Any
		value starting with 'n' will prevent copying of local
		vars, all other values equals `yes'.

	- NoLF (v37.6+)
		Dave Dustin <dave@eclipsnz.manawatu.gen.nz> seemed to have
		problems with the LF that ASyncRun puts at the end of the
		command line before spawning the child. Setting $NoLF to
		`yes' (i.e. anything that starts with 'y') will prevent
		ASyncRun from using this linefeed.

	The environment variables are searched for first as local, then as
	global vars; and first in dir ASyncRun/, then `alone'. Thus the
	search priority is:

		$ASyncRun/varName (local var)
		$varName (local var)
		$ASyncRun/varName (global var)
		$varName (global var)


    NOTES
	Default settings and environment variables are overridden by command
	line arguments!

	If you happen to miss this manual, most of the important things are
	included in the extended help in ASyncRun (i.e. by feeding ASyncRun
	with two ?'s).

	ASyncRun is `pure' and can be made resident.


    BUGS
	Looses 56 bytes per asynchronous call. This bug has been there from
	the earliest version, and I have tried to track it without success.
	It seems to be a `feature' of the SystemTagList() call.


    REQUIREMENTS
	dos.library v37+
	utility.library v37+

	If the Null: device is present it will be used instead of the
	Nil: `device'.


    ACKS
	Thanks to Steffen Salzmann <2:249/125.2@fidonet> for his suggestions
    	and comments during early development. Where are you now, Fenzan?

	Thanks also to Brian Munk Jacobsen <brj@boble.ping.dk> for support.

	Thanks to Dave Dustin <dave@eclipsnz.manawatu.gen.nz> for bug
	reports (the `LF-bug' that happened to be a typo in the taglist for
	the SystemTagList() command).

	Thanks to Stefan Becker <stefanb@yello.ping.de> for letting me
	distribute his WBStart-Handler.

	Thanks to Gunnar Nordmark for the original Null-Handler (1988).


    HISTORY
	37.4	(12-Feb-93)	  First public release, I think.

	37.5	(17-Apr-95)	  Rewritten from scratch.
				  Support for NULL:.
				  SyncRun switch added.

	37.6	(28-Apr-95)	  $def_Pri/$def_Stack/$NoLF env-vars added.
				  WBRun switch added.

	37.7	(30-Apr-95)	  Invisible SystemTagList() bug (AKA typo),
				   that would only let you use a certain
				   custom shell, fixed.
				  $CopyVars env-var added.
				  CD keyword and $def_CD env-var added.
				
	37.8	(05-May-95)	  DoIO switch Added.


    COPYRIGHT ETC.
	ASyncRun is Copyright  1992-95 Magnetic Ink, but freely distribut-
	able as long as this text is left intact and goes along with *ANY*
	distribution.

	Please send comments or bug-reports by e-mail to:


: Klaus :: kas@mink.ping.dk :
: Magnetic Ink :
: Soli Deo Gloria :

-- 

    Let us hear the conclusion of the whole matter: Fear God, and keep his
     commandments, for this is the whole duty of man.
                                                       (Ecclesiastes 12:13)
